hgts = read.csv("jhtgs.csv",na.strings = c("NA","-"))

fhts = hgts[, c(1:5,27:29,6) ]
fhts$Day = hgts$Dat
for( i in 7:26) {
	tmp = hgts[, c(1:5,27:29,i) ]
	tmp$Day = as.integer(substr(names(hgts)[i],5,10))
	names(tmp)= NULL
	fhts = rbind(fhts,tmp,deparse.level=0)
	}

## Greater Than 0 (zero) heights
fhts$HgtGT0 = fhts$initHgt
i = with(fhts, initHgt < 0.1 )
fhts$HgtGT0[i] = NA

## Heights for all living plants
## Avoids the zeroes older than 30 days
fhts$HgtND = fhts$initHgt
i = with( fhts, (Day > 30) & (initHgt < 0.1) )
fhts$HgtND[i] = NA


names( fhts) = c("Soil", "Rep", "Spp","Pot","DatePlanted", 
       "Shoot", "Root", "RSr", "Hgt","AbsDay", "HgtGT0","HgtND")

fhts$Day = with(fhts, AbsDay - DatePlanted)


print(summary(fhts))
save( fhts, file="fhts.RData",compress=T)
