require(nlme)
load("fhts.RData")


zhts = na.omit(fhts[,c(1:7,12,13) ])
zhts = groupedData(HgtND ~ Day | Rep, data=zhts)

## Fits grouped NLS model
nlsR =   nlsList( HgtND ~  SSfpl(Day,Loff,Lmax,xmid,rate),
  data = zhts )

## Make it an NLME
nlmeR = nlme(nlsR)

## Fix for heteroscedacitys
v = varExp()
v = Initialize( v, zhts)
nlmeR.ve = update(nlmeR, random = Lmax ~ 1, 
  weights=v)

## Fixed effects for Spp*Soil
load("ptic.RData")

##################################

##  I
nssPTTT.ve = try( update( nlmeR.ve,
  fixed = list(Loff~ Soil+Spp,  Lmax + xmid + rate ~ Soil*Spp), 
  start = list(fixed= as.vector( c(loffp, lmaxt, xmidt, ratet ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

##  II
nssTPTT.ve = ( update( nlmeR.ve,
  fixed = list(Lmax ~ Soil+Spp,  Loff+ xmid + rate ~ Soil*Spp), 
  start = list(fixed= as.vector( c(lmaxp, lofft, xmidt, ratet ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

## III

nssTTPT.ve = try( update( nlmeR.ve,
  fixed = list(xmid~ Soil+Spp,  Loff + Lmax  + rate ~ Soil*Spp), 
  start =list( fixed=as.vector( c(xmidp, lofft, lmaxt, ratet )) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

##  IV
nssTTTP.ve = try( update( nlmeR.ve,
  fixed = list(rate ~ Soil+Spp,  Loff+ Lmax + xmid ~ Soil*Spp), 
  start = list(fixed= as.vector( c(ratep,lofft, lmaxt, xmidt ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

################################################

##  1
nssPPTT.ve = try( update( nlmeR.ve,
  fixed = list(Loff +Lmax ~ Soil+Spp,   xmid + rate ~ Soil*Spp), 
  start = list(fixed= as.vector( c(loffp, lmaxp, xmidt, ratet ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

##  2
nssPTPT.ve = try( update( nlmeR.ve,
  fixed = list(Loff +xmid~ Soil+Spp,   Lmax + rate ~ Soil*Spp), 
  start = list(fixed= as.vector( c(loffp, xmidp, lmaxt, ratet ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

## 3
nssTPPT.ve = try( update( nlmeR.ve,
  fixed = list(Lmax  + xmid ~ Soil+Spp,   Loff + rate ~ Soil*Spp), 
  start = list(fixed= as.vector( c(lmaxp, xmidp, lofft, ratet ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

##################################

##  I
nssTPPP.ve = try( update( nlmeR.ve,
  fixed = list(Loff~ Soil*Spp,  Lmax + xmid + rate ~ Soil+Spp), 
  start = list(fixed= as.vector( c(lofft, lmaxp, xmidp, ratep ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

##  II
nssPTPP.ve = try( update( nlmeR.ve,
  fixed = list(Lmax ~ Soil*Spp,  Loff+ xmid + rate ~ Soil+Spp), 
  start = list(fixed= as.vector( c(lmaxt, loffp, xmidp, ratep ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

## III
nssPPTP.ve = try( update( nlmeR.ve,
  fixed = list(xmid~ Soil*Spp,  Loff + Lmax  + rate ~ Soil+Spp), 
  start = list(fixed= as.vector( c(xmidt, loffp, lmaxp, ratep ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

##  IV
nssPPPT.ve = try( update( nlmeR.ve,
  fixed = list(rate ~ Soil*Spp,  Loff+ Lmax + xmid ~ Soil+Spp), 
  start = list(fixed= as.vector( c(ratet,loffp, lmaxp, xmidp ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

################################################

##  1
nssTTPP.ve = try( update( nlmeR.ve,
  fixed = list(Loff +Lmax ~ Soil*Spp,   xmid + rate ~ Soil+Spp), 
  start = list(fixed= as.vector( c(lofft, lmaxt, xmidp, ratep ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

##  2
nssTPTP.ve = try( update( nlmeR.ve,
  fixed = list(Loff +xmid~ Soil*Spp,   Lmax + rate ~ Soil+Spp), 
  start = list(fixed= as.vector( c(lofft, xmidt, lmaxp, ratep ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

## 3
nssPTTP.ve = try( update( nlmeR.ve,
  fixed = list(Lmax  + xmid ~ Soil*Spp,   Loff + rate ~ Soil+Spp), 
  start = list(fixed= as.vector( c(lmaxt, xmidt, loffp, ratep ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))


#################################
## A
nssTTTT.ve = try( update( nlmeR.ve,
  fixed = list(Loff +rate + Lmax + xmid  ~ Soil*Spp), 
  start = list(fixed= as.vector( c(lofft, ratet, lmaxt, xmidt ) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))

## B 
nssPPPP.ve = try( update( nlmeR.ve,
  fixed = list(Loff + Lmax + xmid + rate ~ Soil+Spp), 
  start = list(fixed= as.vector( c(loffp, lmaxp, xmidp, ratep) ) ),
  control = list(maxIter=100, pnlsMaxIter =21, msMaxIter=100,
    minScale=0.0001, niterEM=50,
    pnlsTol=1e-3,  maTol=1e-7,
    returnObject=TRUE,
    msVerbose=TRUE,
    nlmStepMAx=200.0
    )))



save.image(file="fitHgtLmF.RData")

